var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useCallback, useEffect, useState } from "react";
import Calendar, { Skeleton, } from "react-activity-calendar";
import { DEFAULT_THEME } from "./constants";
import { fetchCalendarData, transformData } from "./utils";
var LeetcodeCalendar = function (_a) {
    var _b;
    var username = _a.username, labels = _a.labels, _c = _a.year, year = _c === void 0 ? "last" : _c, transformFn = _a.transformData, _d = _a.transformTotalCount, transformTotalCount = _d === void 0 ? true : _d, _e = _a.throwOnError, throwOnError = _e === void 0 ? false : _e, _f = _a.errorMessage, errorMessage = _f === void 0 ? "Error Fetching LeetCode submission data for \"".concat(username, "\" failed.") : _f, props = __rest(_a, ["username", "labels", "year", "transformData", "transformTotalCount", "throwOnError", "errorMessage"]);
    var _g = useState(null), data = _g[0], setData = _g[1];
    var _h = useState(false), loading = _h[0], setLoading = _h[1];
    var _j = useState(null), error = _j[0], setError = _j[1];
    var _k = useState(0), totalCount = _k[0], setTotalCount = _k[1];
    var fetchData = useCallback(function () {
        setLoading(true);
        setError(null);
        fetchCalendarData(username)
            .then(function (data) {
            setData(data);
            var total = Object.values(data.submissionCalendar).reduce(function (sum, count) { return sum + count; }, 0);
            setTotalCount(total);
        })
            .catch(function (err) { return setError(err.message); })
            .finally(function () { return setLoading(false); });
    }, [username]);
    useEffect(fetchData, [fetchData]);
    if (error) {
        if (throwOnError) {
            throw error;
        }
        else {
            return _jsx("div", { children: errorMessage });
        }
    }
    if (loading || !data) {
        return _jsx(Skeleton, __assign({}, props, { loading: true }));
    }
    var theme = (_b = props.theme) !== null && _b !== void 0 ? _b : DEFAULT_THEME;
    var defaultLabels = {
        totalCount: "".concat(totalCount, " submissions in the last year"),
    };
    return (_jsx(Calendar, __assign({ data: transformData(data.submissionCalendar, transformFn), theme: theme, labels: Object.assign({}, defaultLabels, labels), totalCount: totalCount }, props, { loading: Boolean(props.loading) || loading, maxLevel: 4 })));
};
export default LeetcodeCalendar;
